## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <https://www.gnu.org/licenses/>.

## Author: Armin Auf der Maur <armin@LAPTOP-UL2NPON7>
## Created: 2021-06-28
%% Kind of randomization test. Bootstrapping to test for H0, title: H0booty
%% R1dif2rr3: 1 = R, 2 = dif, 3 = rr (0 for hits in the tea tasting experiment)

function [retval] = H0booty(input1, input2, R1dif2rr3 = 2);
N=10000, %for precision change to N = 100000,
y = load(input1); % outcome
x = load(input2); % treatment
n =length(y); Sxn =(sum(x))/n; avy=mean(y); ns =(n-length(x(x ==0)));
stx =std(x, 1); sty =std(y, 1); stxy =stx *sty;
R = (mean(x .* y)-mean(x)*mean(y)) /(stxy),
CorTie =-sign(R)/N;
hit = 0; for (i = 1:n),  if (y(i).-x(i) ==0), ++hit; endif, endfor,
dif = (sum(x .* y)-Sxn*sum(y))*Sxn /(var(x, 1) *ns),
Rcr=avy*stx/(mean(x)*sty); rr=1+(n/ns)/(-1+Rcr/R),
nB4 = n /kurtosis(y), % effective sample size
P = 0; hiti =zeros(1, N); difi =zeros(1, N); rri =zeros(1, N);
for (i = 1:N)
ye=empirical_rnd(y); xe =x;
# xe =empirical_rnd(x); %bootstrapping may concern y, x, or both 
stye =std(ye, 1); stxe =std(xe, 1); stxye =stye *stxe;
if(stxye <=CorTie); continue, endif,
avye =mean(ye); avxe=mean(xe); avxye=avxe *avye; nse =(n-length(xe(xe ==0)));
xye=mean(ye.*xe);Rj=(xye-avxye)/stxye;
cdife=stye*avxe*n/(stxe*ns); Rcre=avye*stxe/(avxe*stye); 
switch (R1dif2rr3)
case (0)
hj=0;
for (j = 1:n),  if (ye(j)-xe(j) ==0); ++hj; endif, endfor,
hiti(i) = hj;
case (1)
Ri(i) =Rj;
case (2)
difi(i) = Rj *cdife;
case (3)
Rc1 =0.9*Rcre; Rc2 =-0.9*Rcre*(nse/(n-nse));
rp=max(min(Rj,Rc1),Rc2);
rri(i)=max(min(1+(n/nse)/(-1+Rcre /rp),99),0.1);
endswitch, endfor
z =[1:N]; if(rem(N, 2)==0), z1=[1:N/2, N-[N/2:N-1]];
else, z1=[1:N/2+0.5, N-[0.5+N/2:N-1]]; endif,

switch (R1dif2rr3)
case (0)
hit;
hiti = sort(hiti);
Phit = lookup(hiti, hit +CorTie)/N; 
if(R ==0),Phit =(Phit +lookup(hiti,hit-1/N)/N)/2; endif
Phit =min(Phit, 1 -Phit),

semilogy(hiti, z1/N, ".r", hit, Phit, 'xr');
xlabel ("hits"); 
ylabel ("P");

case (1)
Ri = sort(Ri);
PRH0 = lookup(Ri, R +CorTie)/N; PRH0 =min(PRH0, 1-PRH0),
meanRi = mean(Ri), medRi = median(Ri), #msste bei 0 sein

semilogy(Ri, z1/N, "r", R, PRH0, "xr")
xlabel ("R")

case (2)
difi = sort(difi);
PdifH0 = lookup(difi, dif +CorTie)/N; PdifH0 =min(PdifH0, 1-PdifH0),
meandif = mean(difi), meddif = median(difi), #msste bei 0 sein

semilogy(difi, z1/N, "r", dif, PdifH0, "xr")
xlabel ("dif (MJ)")

case (3)
rri = sort(rri);
PrrH0 = lookup(rri, rr +CorTie)/N; PrrH0 =min(PrrH0, 1-PrrH0),
meanrr = mean(rri), medrr = median(rri), #msste bei 0 sein
loglog(rri, z1/N, "r", rr, PrrH0, "xr")
%semilogy(rri, z1/N, "r", rr, PrrH0, "xr")
xlabel ("rr")
endswitch
ylabel ("P"), grid minor on, hold on,
%res = [rr]; 
%res1 = res';
%save rrES.txt res1;
endfunction